//index.js
//获取应用实例
const app = getApp()
 
Page({
  data: {
    username: '',
    btnValue:'获取验证码',
    btnDisabled:false,
    second: 60,
    sysinfo: '',
    nxtdata: ''
  },
  //事件处理函数
  bindViewTap: function() {
    wx.navigateTo({
      url: '../logs/logs'
    })
  },
  onShow: function () {
    // 生命周期函数--监听页面显示
    wx.hideTabBar({})
  },
  onLoad: function () {
    console.log('index.js begin');
    this.getOpenId();
  },

  onReady: function () {   
  },

  getOpenId: function() {
    var that = this;
    var timezone_off_set=new Date().getTimezoneOffset();
    console.log('timezone_off_set='+timezone_off_set);
    wx.getSystemInfo({
      success: (result) => {
        that.setData({
          sysinfo:result
        })
      },
    })
    console.log(that.data.sysinfo);
    wx.login({
      success (res) {
        if (res.code) {
          //发起网络请求
          console.log("code="+res.code);
          wx.request({
            url: app.globalData.webUrl+ '/NxtJsServlet?mode=getWxOpenId',
            data: {  
              sys_info: that.data.sysinfo,
              js_code: res.code,
              timezone_off_set:timezone_off_set
            },
            method:"get",
            success:function(nxt_result){
              that.setData({
                nxtdata: nxt_result.data
              })
              console.log('openid='+that.data.nxtdata.openid+',sign='+that.data.nxtdata.sign)      
            }
          })
        } else {
          console.log('登录失败！' + res.errMsg)
        }
      }
    })
  },
 
 
  // 获取输入账号 
  usernameInput: function (e) {
    this.setData({
      username: e.detail.value
    })
  },
 
  // 获取输入密码 
  vCodeInput: function (e) {
    this.setData({
      verifycode: e.detail.value
    })
  },

  smsSend: function(){
    var that = this;
    if(this.data.username.length==0){
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none',
        duration: 2000
      })
    }else{
      console.log('username='+this.data.username);
       this.setData({
              btnValue: '短信发送中',
              btnDisabled: true
         })
      wx.request({
        url: app.globalData.webUrl+'/wx_msg.jsp?mode=sms', // 仅为示例，并非真实的接口地址
        method: 'post',
        data: {
          mobile: that.data.username,
          nxtdata: that.data.nxtdata
        },
        success:function(res){
          console.log(res.data);
          var ret=(res!=null) ? res.data.ret : '';
          if(ret=='0'){
            that.timer();
          }else{
            that.setData({
                btnValue: '重新获取',
                btnDisabled: false
            })
          }
        },
        fail: function (err) {
          that.setData({
              btnValue: '重新获取',
              btnDisabled: false
          })
          console.log('err='+err.errMsg);
        }
      }
    )}
  },

  timer: function () {
      let promise = new Promise((resolve, reject) => {
       let setTimer = setInterval(() => {
         var second = this.data.second - 1;
         this.setData({
          second: second,
          btnValue: second+'秒',
          btnDisabled: true
         })
         if (this.data.second <= 0) {
          this.setData({
           second: 60,
           btnValue: '获取验证码',
           btnDisabled: false
          })
          resolve(setTimer)
         }
        }
        , 1000)
      })
      promise.then((setTimer) => {
       clearInterval(setTimer)
      })
     },
 
  // 登录处理
  login: function () {
    var that = this;
    if (this.data.username.length == 0 || this.data.verifycode.length == 0) {
      wx.showToast({
        title: '账号或验证码不能为空',
        icon: 'none',
        duration: 2000
      })
    } else {
      wx.request({
        url: app.globalData.webUrl+'/wx_msg.jsp', // 仅为示例，并非真实的接口地址
        method: 'post',
        data: {
          mobile: that.data.username,
          verifycode: that.data.verifycode,
          nxtdata: that.data.nxtdata
        },
        success(res) {
          console.log(res);
          if (res.data.code == "OK") {
            var unitName = res.data.data.User.unitName;
            var unitId = res.data.data.User.unitId;
            wx.setStorageSync('unitId', unitId);
            wx.setStorageSync('unitName', unitName);
            wx.switchTab({
              url: '../overviewData/realTimeData'
            })
          } else {
            wx.showToast({
              title: res.data.message,
              icon: 'none',
              duration: 2000
            })
          }
        }
      })
    }
  }
})
 