package com.newxtc.fw.client.run;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.newxtc.fw.client.util.HttpClient;
import com.newxtc.fw.client.util.JsonParamUtil;

public class FwTask implements Runnable {
	private final static Logger logger = LoggerFactory.getLogger(FwTask.class);
	private final int outOfTime = 500;

	private Map<String, Object> paramMap = null;

	public FwTask(Map<String, Object> inputMap) {
		this.paramMap = inputMap;
	}

	public void run() {
		Object eventType = null, status = null;
		try {
			Object objToken = (paramMap != null) ? paramMap.get("nxtToken") : null;
			String nxtToken = (objToken != null) ? objToken.toString() : null;
			String tokenId = "";
			if (nxtToken != null && nxtToken.length() >= 64) {
				eventType = paramMap.get("EVENT_TYPE");
				status = paramMap.get("status");
				tokenId = nxtToken.substring(0, 32);
			} else {
				logger.error("execReq() objToken=" + objToken);
				return;
			}
			long beginTime = System.currentTimeMillis();
			if (status.equals("0") || status.equals("1") || status.equals("-1")) {
				Map<String, Object> signParam = JsonParamUtil.getSignParam(paramMap);
				String jsonRes = (signParam != null) ? HttpClient.execClient("fireWareUrl", "FwServlet", paramMap, outOfTime) : null;
				JSONObject retJson = (jsonRes != null && jsonRes.contains("{") && jsonRes.contains("}")) ? JSON.parseObject(jsonRes) : null;
				if (retJson != null && retJson.size() > 0) {
					String orderNo = retJson.getString("orderNo");
					String reasonCode = retJson.getString("reasonCode");
					long cost = System.currentTimeMillis() - beginTime;
					logger.info(eventType + "(" + status + "):" + tokenId + " -> " + orderNo + ",reasonCode=" + reasonCode + ",cost=" + cost);
				} else {
					logger.error("run() inputMap=" + paramMap + ",jsonRes=" + jsonRes);
				}
			} else {
				logger.error("run() status not in(0,1,-1) status=" + status);
			}
		} catch (Exception e) {
			logger.error("run() e=" + e.toString());
		}
	}
}
